def binom2r(n,k):
  if k==0: return 1
  return binom2r(n,k-1)*(n-k+1)//k

def binom2i(n,k):
  X=1
  for i in range(1,k+1): X=X*(n-i+1)//i
  return X

def binom3r(n,k):
  if k==0: return 1
  return binom3r(n-1,k-1)*n//k

def binom3i(n,k):
  X=1
  for j in range(1,k+1): X=X*(n-k+j)//j
  return X
  
def facto(n):
# Factorial of an integer
  p=1
  for k in range(1,n+1): p=p*k
  return p 
  
def binom4(n,k):
# Binomial coefficient, based upon factorials
  return (facto(n)//facto(k))//facto(n-k)
  
def recbin(n,k):
   if k==0 or n==k: return 1
   return recbin(n-1,k)+recbin(n-1,k-1) # triangle rule

def line(n): # computes a Pascal's triangle line
  n=n+1; L=[0]*n; L[0]=1 #initializations
  for i in range(n):
    for j in range(i,0,-1): # RTL
      L[j]=L[j-1]+L[j]    # overwriting
  return L

def triangle(n): # returns Pascal's triangle
  n=n+1; P=[]
  L=[0]*n; L[0]=1 #initializations
  for i in range(n):
    for j in range(i,0,-1): # RTL
      L[j]=L[j-1]+L[j]    # overwriting
    P.append(list(L)) # list(L) creates a new list from L
  return P

from time import *

def test(m,p): #testing all the above
  print("Testing for m=",m," and p=",p)
  print("binom2r:",binom2r(m,p))
  print("binom2i:",binom2i(m,p))
  print("binom3r:",binom3r(m,p))
  print("binom3i:",binom3i(m,p))
  print("binom4:",binom4(m,p))
  for s in triangle(m):print(s)
  t=clock()
  recbin(m,p)
  print("Delay for recbin(",m,",",p,")",int(clock()-t))
